import { type History } from "history";
import { type Store } from "redux";
import { type SagaMiddleware } from "redux-saga";
import { type Logger, type LoggerConfig, LoggerImpl } from "./Logger";
import { type ActionHandler, type ErrorHandler } from "./module";
import { type State } from "./reducer";
interface App {
    readonly history: History;
    readonly store: Store<State>;
    readonly sagaMiddleware: SagaMiddleware<any>;
    readonly actionHandlers: {
        [actionType: string]: {
            handler: ActionHandler;
            moduleName: string;
        };
    };
    readonly logger: LoggerImpl;
    loggerConfig: LoggerConfig | null;
    errorHandler: ErrorHandler;
}
export declare const app: App;
export declare const logger: Logger;
export {};
//# sourceMappingURL=app.d.ts.map