import type { State } from "../reducer";
import type { SagaGenerator } from "../typed-saga";
import type { ActionHandler } from "../module";
import type { Module } from "../platform/Module";
type ActionHandlerWithMetaData = ActionHandler & {
    actionName: string;
    maskedParams: string;
};
type HandlerInterceptor<RootState extends State = State> = (handler: ActionHandlerWithMetaData, thisModule: Module<RootState, any>) => SagaGenerator;
/**
 * A helper for ActionHandler functions (Saga).
 */
export declare function createActionHandlerDecorator<RootState extends State = State, This extends Module<RootState, string> = Module<RootState, string>, Fn extends (this: This, ...args: any[]) => SagaGenerator = ActionHandler>(interceptor: HandlerInterceptor<RootState>): (fn: Fn, context: ClassMethodDecoratorContext<This, Fn>) => (this: This, ...args: any[]) => SagaGenerator;
export {};
//# sourceMappingURL=createActionHandlerDecorator.d.ts.map