import { uuid } from "../util/uuid";
/**
 * CAVEAT:
 * In Apple Safari, the user may block sessionStorage access via setting "Block All Cookies".
 * The following code will throw error in such case.
 * Ref: https://codingrepo.com/javascript/2018/11/15/safari-securityerror-dom-exception-18-thrown-by-localstorage-or-cookies-are-blocked/
 */
function getSessionId() {
    try {
        var token = "@@framework-session-id";
        var previousId = sessionStorage.getItem(token);
        if (previousId) {
            return previousId;
        }
        else {
            var newId = uuid();
            sessionStorage.setItem(token, newId);
            return newId;
        }
    }
    catch (e) {
        return uuid();
    }
}
export var loggerContext = {
    request_url: function () { return location.href; },
    session_id: getSessionId(),
};
//# sourceMappingURL=logger-context.js.map