import { __assign, __awaiter, __extends, __generator } from "tslib";
import React from "react";
import { app } from "../app";
import { loadingAction } from "../reducer";
import { captureError, errorToException } from "./error-util";
var ASYNC_LOAD_ACTION = "@@framework/async-import";
export function async(resolve, component, _a) {
    var _b = _a === void 0 ? {} : _a, moduleName = _b.moduleName, LoadingComponent = _b.LoadingComponent, loadingIdentifier = _b.loadingIdentifier, ErrorComponent = _b.ErrorComponent;
    return /** @class */ (function (_super) {
        __extends(AsyncWrapperComponent, _super);
        function AsyncWrapperComponent(props) {
            var _this = _super.call(this, props) || this;
            _this.loadComponentWithAutoRetry = function (maxRetryTime) { return __awaiter(_this, void 0, void 0, function () {
                var retryCount, startTime, loadChunk, e_1;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            retryCount = 0;
                            startTime = Date.now();
                            loadChunk = function () { return __awaiter(_this, void 0, void 0, function () {
                                var moduleExports, e_2;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            _a.trys.push([0, 2, , 6]);
                                            return [4 /*yield*/, resolve()];
                                        case 1:
                                            moduleExports = _a.sent();
                                            this.setState({ Component: moduleExports[component] });
                                            return [3 /*break*/, 6];
                                        case 2:
                                            e_2 = _a.sent();
                                            if (!(retryCount++ < maxRetryTime)) return [3 /*break*/, 4];
                                            app.logger.warn({
                                                action: ASYNC_LOAD_ACTION,
                                                elapsedTime: Date.now() - startTime,
                                                errorCode: "LOAD_CHUNK_FAILURE_RETRY",
                                                errorMessage: errorToException(e_2).message,
                                                context: { module_name: moduleName },
                                                stats: { retry_count: retryCount },
                                            });
                                            return [4 /*yield*/, loadChunk()];
                                        case 3:
                                            _a.sent();
                                            return [3 /*break*/, 5];
                                        case 4: throw e_2;
                                        case 5: return [3 /*break*/, 6];
                                        case 6: return [2 /*return*/];
                                    }
                                });
                            }); };
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, 4, 5]);
                            this.setState({ error: null });
                            app.store.dispatch(loadingAction(true, loadingIdentifier));
                            return [4 /*yield*/, loadChunk()];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 5];
                        case 3:
                            e_1 = _a.sent();
                            captureError(e_1, ASYNC_LOAD_ACTION);
                            this.setState({ error: e_1 });
                            return [3 /*break*/, 5];
                        case 4:
                            app.store.dispatch(loadingAction(false, loadingIdentifier));
                            app.logger.info({
                                action: ASYNC_LOAD_ACTION,
                                elapsedTime: Date.now() - startTime,
                                context: { module_name: moduleName },
                            });
                            return [7 /*endfinally*/];
                        case 5: return [2 /*return*/];
                    }
                });
            }); };
            _this.loadComponent = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                return [2 /*return*/, this.loadComponentWithAutoRetry(0)];
            }); }); };
            _this.state = { Component: null, error: null };
            return _this;
        }
        AsyncWrapperComponent.prototype.componentDidMount = function () {
            this.loadComponentWithAutoRetry(2);
        };
        AsyncWrapperComponent.prototype.render = function () {
            var _a = this.state, Component = _a.Component, error = _a.error;
            var hasError = error !== null;
            if (hasError) {
                return ErrorComponent ? React.createElement(ErrorComponent, { error: error, reload: this.loadComponent }) : null;
            }
            return Component ? React.createElement(Component, __assign({}, this.props)) : LoadingComponent ? React.createElement(LoadingComponent, null) : null;
        };
        return AsyncWrapperComponent;
    }(React.PureComponent));
}
//# sourceMappingURL=async.js.map